<?php
	class Shopware_Controllers_Backend_BuiswCleverReach extends Enlight_Controller_Action {
		/*
		 * init class
		 */
		public function init() {
			$this->View()->addTemplateDir(dirname(__FILE__) . '/Views/Backend/');
		}

		/*
		 * switch for template-skeletons
		 */
		public function skeletonAction() {
			$action = Shopware()->Front()->Request()->getPost('target_action');
			$this->View()->assign('action', $action);

			if ($action == 'Register') {
				$this->View()->assign('actionTitle', 'Kostenlosen CleverReach Account erstellen');
				$this->View()->loadTemplate('register.tpl');
			} elseif ($action == 'Lists') {
				$this->View()->assign('actionTitle', 'Listen-Zuordnung');
				$this->View()->loadTemplate('skeleton.tpl');
			} elseif ($action == 'Export') {
				$this->View()->assign('actionTitle', 'Erst-Export');
				$this->View()->loadTemplate('skeleton.tpl');
			} elseif($action == 'RegisterProductsSearch') {
				$this->View()->assign('actionTitle', 'Produkt-Suche aktivieren');
				$this->View()->loadTemplate('skeleton.tpl');
			}
		}

		/*
		 * template for lists-assignments
		 */
		public function listsAction() {
			$this->View()->loadTemplate('lists.tpl');
		}

		/*
		 * first export
		 */
		public function exportAction() {
			Shopware()->Plugins()->Controller()->ViewRenderer()->setNoRender();

			$this->startFirstExport();
		}

		/*
		 * save shop-customer groups-lists assignments
		 */
		public function saveListsAssignmentsAction() {
			Shopware()->Plugins()->Controller()->ViewRenderer()->setNoRender();

			$post = $this->Request()->getPost();

			if(count($post) == 0)
				$post = $this->getRealPOST();

			foreach($post['BuiswCleverReachListsCenterFormTabpanelContainerCustomergroupsTextfield'] as $shopkey => $shopvalues) {
				foreach($shopvalues as $customergroupkey => $customergrouplistid) {
					if(Shopware()->Db()->fetchOne('SELECT COUNT(*) FROM s_bui_plg_cleverreach_assignments WHERE shop='.$shopkey." AND customergroup=".$customergroupkey) == 0)
						Shopware()->Db()->insert('s_bui_plg_cleverreach_assignments', array('shop' => $shopkey, 'customergroup' => $customergroupkey, 'listid' => $customergrouplistid));
					else
						Shopware()->Db()->update('s_bui_plg_cleverreach_assignments', array('listid' => $customergrouplistid), 'shop='.$shopkey." AND customergroup=".$customergroupkey);
				}
			}
		}

		public function getRealPOST() {
			$pairs = explode("&", file_get_contents("php://input"));
			$vars = array();

			foreach ($pairs as $pair) {
				$nv = explode("=", $pair);
				$name = urldecode($nv[0]);
				$value = urldecode($nv[1]);

				if(preg_match ('/(\[.*)/', $name, $m)) {
					$name = str_replace ($m[1], '', $name);
					$toeval = 'unset ($value);$arr' . $m[1] . '="' . $value . '";';
					eval ($toeval);
				}
			}

			$vars[$name] = $arr;

			return $vars;
		}

		/*
		 * get data for the lists-assignments template
		 */
		public function getListsAssignmentsDataAction() {
			Shopware()->Plugins()->Controller()->ViewRenderer()->setNoRender();

			$data = array();

			$data['shops'] = $this->getShops();
			$data['customergroups'] = $this->getCustomergroups();
			$data['customergroupsvalues'] = $this->getSavedAssignments();

			echo json_encode($data);
		}

		/*
		 * get shops
		 */
		public function getShops() {
			$shops = array();

			$records = Shopware()->Db()->fetchAll('SELECT id, name FROM s_core_multilanguage ORDER BY name');

			foreach($records as $r)
				$shops[$r['id']] = utf8_encode($r['name']);

			return $shops;
		}

		/*
		 * get customer groups
		 */
		public function getCustomergroups() {
			$customergroups = array();

			$customergroups[0] = 'Bestellkunden';

			$records = Shopware()->Db()->fetchAll('SELECT id, description FROM s_core_customergroups ORDER BY description');

			foreach($records as $r)
				$customergroups[$r['id']] = utf8_encode($r['description']);

			$customergroups[100] = 'Interessent';

			return $customergroups;
		}

		/*
		 * get saved assignments from DB
		 */
		public function getSavedAssignments() {
			$customergroupsvalues = array();

			$records = Shopware()->Db()->fetchAll('SELECT shop, customergroup, listid FROM s_bui_plg_cleverreach_assignments ORDER BY shop, customergroup');

			if(count($records) > 0)
				foreach($records as $r)
					$customergroupsvalues[$r['shop']][$r['customergroup']] = utf8_encode($r['listid']);

			return $customergroupsvalues;
		}

		public function registerProductsSearchAction() {
			Shopware()->Plugins()->Controller()->ViewRenderer()->setNoRender();

			$config = Shopware()->Plugins()->Frontend()->BuiswCleverReach()->Config(); // api_key | wsdl_url | export_limit

			$api = new SoapClient($config->wsdl_url);

			$url = 'http://' . Shopware()->Config()->basepath . '/sViewport,BuiswCleverReach/sAction,searchProducts';

			try {
				$result = $api->clientRegisterMyProductSearch($config->api_key, "Shopware - ".Shopware()->Shop()->getName(), $url);
			}
			catch (Exception $e) {
					die ($e->getMessage());
				}

			if($result->status == 'SUCCESS')
				echo "Produkt-Suche erfolgreich aktiviert";
			elseif($result->status == 'ERROR' && $result->statuscode == 50)
				echo 'Produkt-Suche bereits aktiviert';
		}

		##############################################
		###########   First Export Start   ###########
		##############################################

		/*
		 * start the first export
		 */
		public function startFirstExport($config) {
			$config = Shopware()->Plugins()->Frontend()->BuiswCleverReach()->Config(); // api_key | wsdl_url | export_limit

			if($_GET['limit_lower'])
				$limit_lower = $_GET['limit_lower'];
			else
				$limit_lower = 0;

			$export_limit = $config->export_limit;

			if($export_limit > 50 || $export_limit == "")
				$export_limit = 1;

			if(!$_GET['export_type'])
				self::processExport($limit_lower, $export_limit, $config);
			elseif($_GET['export_type'] == 'interested')
				self::processNewsletterInterested($limit_lower, $export_limit, $config);
		}

		/*
		 * process the first export
		 */
		protected function processExport($limit_lower, $export_limit, $config) {
			// Moeglichkeit 1 - Führt bei manchen Shopware-Installationen zu Fehlern
			//require_once('engine/connectors/api/api.php');
			//$api = new sAPI();
			//$export = $api->export->shopware;

			$data = array();

			// Moeglich 2 - laut Forum soll dies funktionieren ...
			$export = Shopware()->Api()->Export();

			$total_count = count($export->sCustomers());

			if($total_count == 0) {
				self::displayHTML('Export?export_type=interested', 0, $export_limit, 0);
				exit(0);
			}

			$users_step = Shopware()->Db()->fetchCol('SELECT id FROM s_user LIMIT '.$limit_lower.', '.$export_limit);

			$users = $export->sCustomers(array('userIDs' => $users_step));

			foreach($users as $user) {
				$newsletter = Shopware()->Db()->fetchOne('SELECT COUNT(*) FROM s_campaigns_mailaddresses WHERE email="'.$user['email'].'"');
				$registeredTime = strtotime(Shopware()->Db()->fetchOne('SELECT firstlogin FROM s_user WHERE id="'.$user['userID'].'"'));

				$userData = array();
				$attributesData = array();
				$attributesData[] = array('key' => 'firma', 'value' => utf8_encode($user['billing_company']));
				$attributesData[] = array('key' => 'anrede', 'value' => utf8_encode(($user['billing_salutation'] == 'ms') ? 'Frau' : 'Herr'));
				$attributesData[] = array('key' => 'vorname', 'value' => utf8_encode($user['billing_firstname']));
				$attributesData[] = array('key' => 'nachname', 'value' => utf8_encode($user['billing_lastname']));
				$attributesData[] = array('key' => 'strasse', 'value' => utf8_encode($user['billing_street'] . ' ' . $user['billing_streetnumber']));
				$attributesData[] = array('key' => 'postleitzahl', 'value' => utf8_encode($user['billing_zipcode']));
				$attributesData[] = array('key' => 'stadt', 'value' => utf8_encode($user['billing_city']));
				$attributesData[] = array('key' => 'land', 'value' => utf8_encode($user['billing_country']));
				$attributesData[] = array('key' => 'newsletter', 'value' => $newsletter);

				$orders = array();
				$orderData = array();
				$user_orders = Shopware()->Db()->fetchCol('SELECT id FROM s_order WHERE userID='.$user['userID']);
				$orders = $export->sOrderDetails(array('orderIDs' => $user_orders));

				foreach($orders as $order) {
					foreach($order as $orderProduct) {
						$orderTime = strtotime(Shopware()->Db()->fetchOne('SELECT ordertime FROM s_order WHERE id='.$orderProduct['orderID']));

						$orderData[] = array(
							'purchase_date' => $orderTime,
							'order_id' => $orderProduct['orderID'],
							'product' => utf8_encode ($orderProduct['name']),
							'product_id' => $orderProduct['articleID'],
							'quantity' => $orderProduct['quantity'],
							'price' => $orderProduct['price'],
							'source' => 'Shopware Erst-Export'
						);
					}
				}

				$userData['email'] = utf8_encode($user['email']);
				$userData['registered'] = $registeredTime;
				$userData['activated'] = $registeredTime;
				$userData['source'] = 'Shopware Erst-Export';
				$userData['attributes'] = $attributesData;
				$userData['orders'] = $orderData;

				$customergroup = Shopware()->Db()->fetchOne('SELECT id FROM s_core_customergroups WHERE groupkey="'.$user['customergroup'].'"');

				$listID = self::getListID($user['subshopID'], $customergroup, $newsletter);

				$data[$listID][] = $userData;
			}

			self::sendBatchToCleverReach($data, $config);

			if(($limit_lower+$export_limit) >= $total_count) {
				self::displayHTML('Export?export_type=interested', 0, $export_limit, 0);
				exit(0);
			} else {
				self::displayHTML('Export?limit_lower='.($limit_lower+$export_limit), $limit_lower, $export_limit, $total_count);
				exit(0);
			}
		}

		/*
		 * get list-ID assigned to the customer
		 */
		protected function getListID($shop, $customergroup, $status) {
			if($status == 0)
				$customergroup = 0;
			elseif($status == 100)
				$customergroup = 100;

			$listID = Shopware()->Db()->fetchOne('SELECT listid FROM s_bui_plg_cleverreach_assignments WHERE shop='.$shop.' AND customergroup='.$customergroup);

			return $listID;
		}

		/*
		 * process the export from the newsletter interested
		 */
		protected function processNewsletterInterested($limit_lower, $export_limit, $config) {
			$data = array();
			$user = array();

			$total_count = Shopware()->Db()->fetchOne('SELECT COUNT(*) FROM s_campaigns_mailaddresses WHERE customer=0');
			$interested_emails = Shopware()->Db()->fetchCol('SELECT email FROM s_campaigns_mailaddresses WHERE customer=0 LIMIT '.$limit_lower.', '.$export_limit);

			foreach($interested_emails as $email) {
				$emailData = Shopware()->Db()->fetchRow('SELECT salutation, firstname, lastname, street, streetnumber, zipcode, city, added FROM s_campaigns_maildata WHERE email="'.$email.'" AND deleted IS NULL');

				$attributesData = array();
				$attributesData[] = array('key' => 'anrede', 'value' => utf8_encode(($emailData['salutation'] == 'ms') ? 'Frau' : 'Herr'));
				$attributesData[] = array('key' => 'vorname', 'value' => utf8_encode($emailData['firstname']));
				$attributesData[] = array('key' => 'nachname', 'value' => utf8_encode($emailData['lastname']));
				$attributesData[] = array('key' => 'strasse', 'value' => utf8_encode($emailData['street'] . ' ' . $emailData['streetnumber']));
				$attributesData[] = array('key' => 'postleitzahl', 'value' => utf8_encode($emailData['zipcode']));
				$attributesData[] = array('key' => 'stadt', 'value' => utf8_encode($emailData['city']));
				$attributesData[] = array('key' => 'newsletter', 'value' => "1");

				$user[] = array(
					'email' => $email,
					'registered' => strtotime($emailData['added']),
					'activated' => strtotime($emailData['added']),
					'source' => 'Shopware Erst-Export',
					'attributes' => $attributesData
				);
			}

			$clID = Shopware()->Db()->fetchOne('SELECT listid FROM s_bui_plg_cleverreach_assignments WHERE customergroup=100');
			$data[$clID] = $user;

			self::sendBatchToCleverReach($data, $config);

			if(($limit_lower+$export_limit) >= $total_count) {
				echo "Export abgeschlossen";
				exit(0);
			} else {
				self::displayHTML('Export?limit_lower='.($limit_lower+$export_limit).'&export_type=interested', $limit_lower, $export_limit, $total_count);
				exit(0);
			}
		}

		/*
		 * set group attributes to the newsletter-group in CleverReach
		 */
		protected function addAttributes($api, $apiKey, $listID) {
			$api->groupAttributeAdd($apiKey, $listID, "Firma", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Anrede", "gender", '');
			$api->groupAttributeAdd($apiKey, $listID, "Vorname", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Nachname", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Strasse", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Postleitzahl", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Stadt", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Land", "text", '');
			$api->groupAttributeAdd($apiKey, $listID, "Newsletter", "text", '');
		}

		/*
		 * send the users to CleverReach
		 */
		protected function sendBatchToCleverReach($data, $config) {
			$api = new SoapClient($config->wsdl_url);

			foreach($data as $listID => $listData) {
				self::addAttributes($api, $config->api_key, $listID);

				
				try {
				   $response = $api->receiverAddBatch($config->api_key, $listID, $listData);
				}
				catch (Exception $e) {
					die ($e->getMessage());
				}

			}
		}

		/*
		 * display redirect content and progress bar
		 */
		function displayHTML($next_target, $start, $limit, $total) {
			$process = $start / $total * 100;

			if($process > 100) $process = 100;

			$upper = (($start + $limit) > $total) ? $total : ($start + $limit);

			$html='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
				   <html>
					   <head>
						   <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
						   <meta http-equiv="refresh" content="0; URL='.$next_target.'" />
						   <title>CleverReach-Export</title>
						   <style type="text/css"><!--
						   .process_rating_light .process_rating_dark {
							   background:#FF0000;
							   height:15px;
							   position:relative;
						   }

						   .process_rating_light {
							   height:15px;
							   margin-right:5px;
							   position:relative;
							   width:150px;
							   border:1px solid;
						   }
					   --></style>
				   </head>
				   <body>
					   <div class="process_rating_light"><div class="process_rating_dark" style="width:'.$process.'%">'.round($process, 0).'%</div></div>
					   Exportiere Datens&auml;tze von '.$lower.' bis '.$upper.' von Gesamt '.$total.'
				   </body>
			   </html>';

			echo $html;
		}

		##############################################
		############   First Export End   ############
		##############################################
	}
?>
